unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,

  rsWinServiceController;

type
  TForm1 = class(TForm)
    Button1: TButton;
    lblServerApplication: TLabel;
    lblServerExe: TLabel;
    lblServerDirectory: TLabel;
    lblServerPath: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure UpdateServerName;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{------------------------------------------------------------------------------}
{ TForm1.FormCreate }

procedure TForm1.FormCreate(Sender: TObject);
begin

  // initialize - display name the existing server
  UpdateServerName;

end;

{------------------------------------------------------------------------------}
{ TForm1.Button1Click }

procedure TForm1.Button1Click(Sender: TObject);
var
  lsServerExe: String;
begin

  lsServerExe := TrsWinServiceController.GetCOMServerExeName;

 // file browse for server .exe and then register the server
 if TrsWinServiceController.BrowseForCOMServerExe(lsServerExe) then
   begin
   
     Screen.Cursor := crHourGlass;

     try
       TrsWinServiceController.RegisterCOMServer(lsServerExe);
     finally
       Screen.Cursor := crDefault;

     end;

     if (TrsWinServiceController.GetCOMServerExeName = lsServerExe) then
       UpdateServerName
     else
       MessageDlg('Unable to register application as a COM server: ' + lsServerExe, mtWarning, [mbOK], 0)

   end;


end;

{------------------------------------------------------------------------------}
{ TForm1.UpdateServerName }

procedure TForm1.UpdateServerName;
var
  lsServerExe: String;
begin

  // get the currently registered report server
  lsServerExe := TrsWinServiceController.GetCOMServerExeName;

  // update the form to display the name and path of the server
  lblServerExe.Caption := ExtractFileName(lsServerExe);
  lblServerPath.Caption := ExtractFilePath(lsServerExe);

end;

end.
